/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package httpmirror;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author dt
 */
public class HttpMirror {

    BufferedReader in;
    PrintWriter out;
    ServerSocket ssock;
    Socket csock;
    String pfad;

    HttpMirror(int port) {
        try {
            this.ssock = new ServerSocket(port);
            while (true) {
                csock = ssock.accept();
                in = new BufferedReader(
                        new InputStreamReader(
                                csock.getInputStream()));
                out = new PrintWriter(
                        csock.getOutputStream());
                out.print("HTTP/1.0 200 \n");
                out.print("Content-Type: text/html \n\n");
                String zeile;

                String[] tokens;
                while (true) {
                    zeile = in.readLine();
                    if (zeile.length() == 0) {
                        break;
                    }
                    out.println(zeile);

                    if (zeile.startsWith("GET")) {
                        this.processStatusLine(zeile);
                        this.sendeDateiZeilenweise(pfad);
                    }

                }
                out.close();
                in.close();
                csock.close();

            }

        } catch (IOException ex) {
            ex.printStackTrace();
        }

    }

    private void processStatusLine(String zeile) {
        String[] tokensRequestLine;
        String[] tokensAbsoluteURI;
        tokensRequestLine = zeile.split(" ");
        tokensAbsoluteURI = tokensRequestLine[1].split("\\?");
        pfad = tokensAbsoluteURI[0].substring(1);

//out.print("pfad:"+ pfad);
    }

    private void sendeDateiZeilenweise(String pfad) {
        BufferedReader htmlDatei = null;
        String zeile;
        try {
            htmlDatei = new BufferedReader(
                    new FileReader(pfad));

            try {
                while ((zeile = htmlDatei.readLine()) != null) {
                    out.print(zeile);
                }
            } catch (IOException ex) {
                out.print(ex.toString());
            }

        } catch (FileNotFoundException fnfe) {
            out.print("404 file not found:" + htmlDatei);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new HttpMirror(9090);
    }

}
